#! /usr/bin/env racket
#lang racket/base

(module+ main
  (displayln "hi!"))

(struct part (uuid name count use))
(struct tool (uuid name use))



(define tools
  (list
   (tool "abcc5589-2c1e-446d-8af1-b68822df9a28"
         "drill" "make holes for arduino mount")
   (tool "96e51009-f1bd-4054-8131-9bec2cdeb531"
         "wire cutters" "cut wires and strip them for soldering")
   (tool "889a99e3-b0f2-49a7-a2e2-e57c5070ad8e"
         "screw driver" "tighten #4 screws")
   (tool "fde5537b-e283-47f1-8af9-1d0ad97ae2ed"
         "soldering iron" "put solder on wires")
   (tool "5cd23e20-561a-483b-840b-0c6307c2889f"
         "hot glue gun" "attach hair tie to wheel")
   (tool "71a55342-12af-434a-8cb6-a99eef9e343e"
         "electrical tape" "cover solder joints on battery holder")))

(define parts
  (list
   (part "be525dfe-c58e-44ce-98b7-90084c17c9b8"
         "alan wrench" 1 "tighten #6-32 screws")

   (part "8424ec99-7f53-4985-b101-31343787cb29"
         "hot glue (drops)" 10 "hold hair tie to wheel")

   (part "3c064806-a765-4b07-80b0-9b4713bee127"
         "hair tie" 2 "better grip for wheels")

   (part "c7cb21ca-cb0b-4eb0-ab53-e4070090dce0"
         "zip tie" 2 "hold wires to motor")

   (part "6666dca6-426f-492e-8383-1e62eac256b5"
         "steel ball" 1 "third point of contact on ground for moving")

   (part "6167b703-ce2e-4fb2-910c-092cdfccf90b"
         "double stick tape (cm)" 4 "attach breadboard and 4xAA to deck")

   (part "73093d09-394a-4b0b-beab-71120517bf46"
         "deck" 1
         "hold breadboard, sonar mount, motor mount, battery holders")

   (part "d35e803e-860c-449d-9774-78295e501276"
         "breadboard" 1 "hold motor controller and connect wires")

   (part "08def069-0459-494e-9bf6-804821b62f73"
         "arduino" 1 "send signal to motor, process info from sonar")

   (part "5ceac789-d68a-4078-a129-d721a99a8d6d"
         "9v battery" 1 "power for motors")

   (part "41aec402-c435-4fc3-a0e1-d8418d91c51e"
         "9v battery holder" 1 "hold power for motors")

   (part "47ae9666-f7d4-46db-bf90-051280df4d26"
         "AA battery" 4 "power the arduino")

   (part "14de012c-129e-4be2-b88c-c18f40461d38"
         "AA battery holder" 1 "hold power for the arduino")

   (part "bd0d2316-e53d-4532-b057-851cb5581219"
         "nickel plated angle bracket" 4 "hold motor mount and deck together")

   (part "5767d684-0987-4700-aac0-80a2366ef728"
         "sonar" 2 "detect distance between bot and surroundings")

   (part "1399849c-db3b-4333-b8e2-bc64da28c484"
         "sonar holder" 2 "hold the sonar to the deck")

   (part "c84161ef-9916-4955-8e07-b57e46942e18"
         "wheel" 2 "move robot on ground")

   (part "0d577243-8787-4f0b-8c10-b455fadd8f2a"
         "#6 washer" 7 "hold #6 screw head from going through deck grid")

   (part "d74718f7-9b0c-45a5-a03c-372706bc4860"
         "#6-32 screw" 15
         (string-append "hold angle bracket to deck and motor mount\n"
                        "hold ball caster standoff to deck"))

   (part "ed17b7e2-554f-41d4-b43c-cf99bfdf7ce6"
         "motor" 2 "drive wheel to propel bot")

   (part "048b2fc7-e6f0-4cdd-8839-25d96117ae30"
         "motor mount" 2 "drive wheel to propel bot")

   (part "e5710a11-8e71-4f42-8799-59c5bf4334cb"
         "#4 lock nut" 4 "keep motor on motor screw")

   (part "0daa47da-c4d5-41ec-8f3b-5d3358f072b5"
         "#4 screw 1.25 inches" 4 "hold motor to motor mount")

   (part "4b7e5e64-e332-40d5-af20-239ad5ca5fd0"
         "usb a-to-b cable" 1 "program the arduino from computer")

   (part "2586c57d-11ed-40d0-961c-eb9c85611608"
         "dual-half h bridge sn754410ne" 1 "direct power to motors")

   ;; wires
   (part "21239945-0cd0-45b5-872c-1448c7007ca7"
         "male-female jump wires, 2 groups of 4 different colors" 8
         "connect sonar sensor to power and arduino")

   (part "d5eeffc3-debc-445d-a1ea-cb066abf4236"
         "red solid core wire 30 mm" 2
         "make positive lead of battery packs easier to connect to breadboard")

   (part "94f9da12-545b-4962-af43-d9701c1e5499"
         "black solid core wire 30 mm" 2
         "make ground lead of battery packs easier to connect to breadboard")

   (part "dffc57be-ff0a-43c4-8854-c3ba77cefc21"
         "orange solid core wire 120 mm" 1
         "hook arduino pin 9 to motor controller pin \"1A\"")

   (part "0b5d5d22-ce59-4741-94aa-25f9ba2bfd1c"
         "blue solid core wire 120 mm" 1
         "hook arduino pin 9 to motor controller pin \"2A\"")

   (part "d084d477-3273-4444-b61d-ad24766a1751"
         "white solid core wire 120 mm" 1
         "hook arduino pin 8 to motor controller pin \"1,2EN\"")

   (part "434234e1-b6d7-43c3-a871-938fcc895c04"
         "orange solid core wire 90 mm" 1
         "hook arduino pin 5 to motor controller pin \"4A\"")

   (part "5390e8cc-1310-4fb3-bd07-8c9b295c592f"
         "blue solid core wire 90 mm" 1
         "hook arduino pin 4 to motor controller pin \"3A\"")

   (part "f1e4e95f-d069-4b83-b6c4-79dfd122219a"
         "white solid core wire 90 mm" 1
         "hook arduino pin 3 to motor controller pin \"3,4EN\"")

   (part "de7a2ede-1159-4a4e-8c9e-6bb27fbae55d"
         "red solid core wire 25 mm" 1
         "hook motor controller 5v pin to breadboard positive rail")
   ;; c56976ba-aad6-40fe-9faa-04734caa0ee9
   ;; 98be105a-fc82-4622-80f5-988984b3d26c
   ;; 808aac6b-61e5-483f-9ee4-7494e6a377b4
   ;; cb44ca12-74e2-4798-aded-6b32d363443a
   ;; 85f9b62b-f729-4984-9d52-2e621d818ddc
   ;; 6bf4f304-9e76-4924-8e67-813cff21f460
   ;; 40aee24a-4ba1-458b-8830-199e3ecf3b7e
   ;; 770687ff-f34b-48ec-b454-aeb839b6c423
   ;; 806b80d7-db6d-44af-b772-e235b70d2f4f
   ;; 04ff88d5-1c20-4ae7-bb23-0adee033767f
   ;; bfc73bc8-6884-4534-8853-c047728fe960
   ;; 365daaae-56fe-419d-80f5-6173c5bcea0a
   ;; 3f14a0b3-a1bc-4449-897b-e92fb437bc53

   (part "7781754a-b2fe-47dc-b711-2f3f2e95f5e3"
         "green solid core wire 175 mm" 2
         "connect motor controller and motor")

   (part "031d2167-d548-4e9a-a00b-5cdf902e3e84"
         "yellow solid core wire 175 mm" 2
         "transmit power between motor controller and motor")

   (part "182e19ba-383c-40a7-9339-39804d4fca5b"
         "black solid core wire 25 mm" 4
         "hook motor controller ground pins to breadboard ground rails")

   (part "c2df71b6-aee9-45fa-b4a1-8464802302a9"
         "black solid core wire 25 mm" 1
         "hook arduino ground pin to breadboard ground rail")

   (part "890e70d8-176f-421e-865c-e55e29256fb8"
         "black solid core wire 55 mm" 1
         "hook ground rails on breadboard together")

   (part "66a049b6-6652-4a71-85a3-d5fd72a51fc5"
         "red solid core wire 25 mm" 1
         "hook arduino 5v pin to breadboard positive rail")))
